from tkinter import *
from tkinter import messagebox
import random
import math
import time
def array(N1, N2=0, N3=0):
    if N2 == 0 and N3==0:
        return [0 for i in range(N1)]
    elif N3 == 0:
        return [[0 for i in range(N2)] for j in range(N1)]
    else:
        return [[[0 for i in range(N3)] for j in range(N2)] for k in range(N1)]
root=Tk()
root.title("炎のシミュレーション")
canvas=Canvas(root, width=200,height=200,bg='black')
canvas.pack()
Xmax = 5; Ymax = 10; DispR = 1
EPSI = 0.5
SIGMA = 0.25
Sig2 = 0.5 * SIGMA
XSig2 = Xmax - Sig2
YSig2 = Ymax - Sig2
Xmax2=Xmax/2
N=2000        # 粒子の数
NCof=math.sqrt(2000/N)   # 粒子数の正規化比(2000を標準とする)
DT=0.2        # 時間刻み
timerInt=10   # 表示時間間隔
R=array(2,N+1,2); F=array(N+1,2); V=array(2,N+1,2) #Bname=array(N+1)
Btemp=array(N+1)
tFact=0.999
E1 = -48 * EPSI * pow(SIGMA,13)
E2 = 24 * EPSI * pow(SIGMA, 7)
MG = 1; ID1 = 0; ID2 = 1
for i in range(1,N+1):
    F[i][0] = 0; F[i][1] = 0
    V[0][i][0] = 0; V[0][i][1] = 0
i = 0   #分子の生成
while i < N:
    R[0][i + 1][0] = random.random() * (float(Xmax) - 2.0) + 1.0
    R[0][i + 1][1] = random.random() * (Ymax - 2.0) + 1.0
    k = 0; NN = 0
    while True: #便宜的に100回繰り返しても近すぎる座標のとき諦める
      k = k + 1; NN = NN + 1
      dX = R[0][k][0] - R[0][i + 1][0]
      dY = R[0][k][1] - R[0][i + 1][1]
      if dX * dX + dY * dY < 5 or NN > 100: break
    i = i + 1
#■表示
Nrend=17
NrendC=int((Nrend-1)/2)
NrendC2=NrendC*NrendC
#■レンダリング用テーブル作成
def setRendTab():        #表示中に計算するのは効率が悪いので
    global Nrend, NrendC #この表を用意しておく
    A=array(Nrend,Nrend)
    for i in range(Nrend):
        x=i-NrendC
        for j in range(Nrend):
            y=j-NrendC
            r=math.sqrt(x*x+y*y)
            if r<NrendC:
                h=r-NrendC
                A[i][j]=h*h/NrendC2
    return A
#■値の範囲チェック            
def checkRange(D, D1=0, D2=255):
    if D<D1: return D1
    if D>D2: return D2
    return D

def dsp(ID1):
    global N, canvas, R, rendTab,Nrend, NrendC
    #各セルの温度合計を求める
    Tmap=array(200,200)
    canvas.delete("DT")
    Xmn=200; Xmx=0; Ymn=200; Ymx=0
    for i in range(1,N+1):
        X = R[ID1][i][0]*20+50
        Y = R[ID1][i][1]*20
        if Btemp[i]>=0.24: #元々温度が小さい粒子については計算しない
            if X<Xmn: Xmn=X #計算した粒子の範囲を記憶しておく
            if X>Xmx: Xmx=X
            if Y<Ymn: Ymn=Y
            if Y>Ymx: Ymx=Y
            for k1 in range(-NrendC,NrendC+1):  #粒子が広がりを持っている
                YY = int(Y + k1)                #ものとして温度値の合計値
                if YY>=0 and YY<200:            #を計算する
                    i1=k1+NrendC
                    for k2 in range(-NrendC,NrendC+1):
                        XX = int(X + k2)
                        if XX>=0 and XX<200:
                            i2=k2+NrendC
                            Tmap[XX][YY] += rendTab[i2][i1]*Btemp[i]
    #粒子のレンダリング範囲を設定
    Xmn-=NrendC; Ymn-=NrendC; Xmx+=NrendC; Ymx+=NrendC
    Xmn=int(checkRange(Xmn,0,200)); Ymn=int(checkRange(Ymn,0,200))
    Xmx=int(checkRange(Xmx,0,200)); Ymx=int(checkRange(Ymx,0,200))
    if Xmn<Xmx and Ymn<Ymx:#範囲矛盾のチェック(安全のため)
        for i in range(Xmn,Xmx):#レンダリング
            for j in range(Ymn,Ymx):
                if Tmap[i][j] >=1.0:
                    TT=Tmap[i][j]*NCof # 2,000個の合計値を標準とする
                    if   TT>20 : # 温度による色を求める(ここは工夫が必要)
                        RR=255; G=255; B = checkRange(int(85*(TT-30.0))) # 係数　255/30=85
                    elif TT>5 :
                        RR=255; G=checkRange(int(64+7.64*(TT-5))); B=0 # 係数　191/25=7.64
                    else:
                    #elif TT>=1:
                        TT1=TT-1
                        RR=checkRange(int(63.75*(TT1)))  # 係数 255/4=63.75
                        G =checkRange(int(16*(TT1)))        # 係数 64/4=16
                        B=0
                    #else : RR=0;G=0;B=0
                    if RR!=0 or G !=0 or B !=0:
                        C="#%02X%02X%02X" % (RR, G,B)
                        canvas.create_rectangle(i,j,i,j,fill=C,outline=C, tag="DT")
    root.update()
#■力の計算
def force(ID1):
    global N, F, R
    for i in range(1,N+1):
        #以下３行、揺らぎを与えるとき
        #if R[ID1][i][1]< 5:F[i][0] = (random.random()-0.8*random.random())*3
        #else: F[i][0] = (random.random()-1.0*random.random())*3
        #F[i][1] = -random.random() *1.5 #上向きのランダムな力
        #以下２行、揺らぎを与えないとき
        F[i][0] = (random.random()-0.5)*3
        F[i][1] = -random.random() *1.5 #上向きのランダムな力
#■速度の計算
def velocity(ID1,ID2):
    global N, F, V,MG
    DMG=DT/MG
    for i in range(1,N+1):
        V[ID2][i][0] = V[ID1][i][0] + DMG * F[i][0]
        V[ID2][i][1] = V[ID1][i][1] + DMG * F[i][1]
    T = 0 # 温度境界条件
    for i in range(1,N+1):
        VX = V[ID2][i][0]; VY = V[ID2][i][1]
        T += VX * VX + VY * VY
    T = math.sqrt(T) * 0.1
    if T > 0.00001:
        for i in range(1, N+1):
            V[ID2][i][0] /= T; V[ID2][i][1] /= T
#■位置の計算
def place(ID1,ID2):
    global N, V, X, Btemp,tFact
    XX2=Xmax/2
    for i in range(1,N+1):
        R[ID2][i][0] = R[ID1][i][0] + DT * V[ID2][i][0]
        R[ID2][i][1] = R[ID1][i][1] + DT * V[ID2][i][1]
        XX=R[ID2][i][0]-XX2
        YY=(R[ID2][i][1]-Ymax)*0.05
        RR=math.sqrt(XX*XX+YY*YY)
        Btemp[i] *= tFact*math.exp(-0.05*abs(RR))
#■壁への衝突
def wallHit(ID2):
    global Sig2,XSig2, YSig2, Xmax2
    for i in range(1,N+1):
        if R[ID2][i][0] < Sig2:
            R[ID2][i][0] = Sig2
            V[ID2][i][0] = abs(V[ID2][i][0]) * 0.0
        if R[ID2][i][0] > XSig2:
            R[ID2][i][0] = XSig2
            V[ID2][i][0] = -abs(V[ID2][i][0]) * 0.0
        if R[ID2][i][1] < Sig2:  #　煙の粒子が天井に届いたら
            R[ID2][i][0]=Xmax2   #　下から発生する粒子として
            R[ID2][i][1]=YSig2   #　再利用
            Btemp[i]  =1.0
        if R[ID2][i][1] > YSig2:
            R[ID2][i][1] = YSig2
            V[ID2][i][1] = -abs(V[ID2][i][1]) * 0.0
#■シミュレーション
def simulate(ID1, ID2):
    global dspFlag
    if dspFlag: dsp(ID1)
    force(ID1)
    velocity(ID1,ID2)
    place(ID1,ID2)
    wallHit(ID2)
    if dspFlag: root.update_idletasks()
    if dspFlag: root.update()
#■画面コピー用マウスイベント  
def leftMouseDown(event):
    global ID1, ID2
    ID2=1-ID1
    simulate(ID1, ID2)
    ID1=ID2
#■メイン処理
rendTab=setRendTab()
ID1=0
ID2=1-ID1
dspFlag=False
#■粒子が連続的に発生するよう初期調整
simulate(ID1,ID2); ID1=ID2
checkN=int(N/100)
k=0; NK=1
for i in range(1,N+1):
    k+=1
    if (k % checkN) ==0:
        canvas.delete("DT")
        canvas.create_text(100,20,text="準備中です(%2d %%)" % int(i/N*100),
                           font=('Times',10),fill='yellow', tag="DT")
        canvas.create_text(100,40,text="■"*NK,
                           font=('Times',10),fill='yellow', tag="DT")
        NK+=1
        if NK>20: NK=1
        root.update()
    R[ID2][i][0]=Xmax/2
    R[ID2][i][1]=Ymax-(0.5*SIGMA)
    Btemp[i]=1.0
    #time.sleep(0.001)
    simulate(ID1,ID2)
canvas.delete("DT")    
dspFlag=True
#■左ボタンクリックしながら画面コピーするとき次の2行のコメントを外す
#canvas.bind("<Button-1>",leftMouseDown)  #画面コピー用マウス
#root.mainloop()
#■シミュレーション開始
while True:
    ID2=1-ID1
    #t1=time.clock()
    simulate(ID1,ID2)
    #t2=time.clock()
    #print(t2-t1)
    #time.sleep(0.001)
    ID1=ID2
